//+------------------------------------------------------------------+
//|                                           Swan_ADX_CCI_N1.17.mq4 |
//|                                         Copyright  2011, skumen |
//|                                                skumen@rambler.ru |
//|                                           http://ruforum.mt5.com |
//+------------------------------------------------------------------+
//--------  Swan_Test_8  ir0407(wlmaster@mail.ru)----------|
//--------  ADX_CCI  Night(alfonius@yandex.ru)-------------|

//N1.03       Market Execution;
//        LotsExponent -  (  StartLots   .);
//N1.04          ;
//N1.06   : " Turbo", Risk %, " CCI-2" ( 2 CCI   ); 
//N1.07    "Turbo" ,  :   = 2/5 ,  = 4/5;
//N1.09    Risk %;
//N1.10    GlobalVariable;  MM_MinLot;
//N1.13   MM_MinLot   StartLots; Risk % -  ;
//N1.14   : LotsRoundUp -    a ;
//N1.14+    NewCycle (Night);
//N1.16     Pipstep  3- ;
//N1.17     "Turbo";
//          "Turbo": "1" -   = 3/5 ; "2" -   = 2/5 ,  = 4/5;


#property copyright ""
#property link      ""

#include <stderror.mqh>
#include <stdlib.mqh>

extern string w1 = "NewCycle -     ";
extern bool   NewCycle = TRUE;         // FALSE -     
                                             
extern double StartLots        = 0.1;  //  
extern double LotsExponent     = 0.4;  //   StartLots   .  (a )(0.1...1) 
extern int    StaticTakeProfit = 20;   //   
extern int    StaticPipstep    = 30;   //   
extern double PipStepExponent  = 1.3;  //       (1....1.6)
extern int    Turbo            = 1;    //  "0" -  "Turbo" (0...2)                                       
extern double Risk             = 0.3;  //    %  ,  = 0,  StartLots                                                                                                                                                                                    
extern double MaxLot           = 2;    //   ,  
extern int    MaxStepCount     = 5;    //     

extern string t2 = " ADX ";
extern double DeltaADX         = 0.8;  //  ADX    ,  DeltaADX    (0.5....1.5)
extern double StopADX          = 65;   // 50-100     ADX
extern int    PeriodADX        = 15;   //   (7...11...15)

extern string t3 = " CCI   ";
extern int    Drop1            = 110;  //  CCI-1  ,      
extern int    Drop2            = 70;   //  CCI-2  
extern string t4 = " CCI";
extern int    Per1             = 30;   //  CCI-1
extern int    Per2             = 75;   //  CCI-2

extern int    MN_Buy           = 222;  // Magic Number  Buy-(     "0").
extern int    MN_Sell          = 333;  // Magic Number  Sell-(     "0").
extern bool   Debug            = TRUE; // /    (    ).

string txt1 = "", ExpertName = "Swan_ADX_CCI_N1.17";
bool InitFail, ExpertStopped;
int LotsDecimal, BuyOrders, SellOrders, NewBarOpenTime = 0;
datetime  LastTickTime;
double BuyStartLot, SellStartLot;


int init()
{
  InitFail = False;
  ExpertStopped = False;
  Comment("");

  if(!IsTradeAllowed()) 
  {
    Comment("\n .\n    \n"+
            "  \n .\n");
    Print(" .   .");
    InitFail = True; 
    return(0);
  }
  if(!IsLibrariesAllowed())
  {
    Comment("\n .\n    \n"+
            "    \n .\n");
    Print(" .     .");
    InitFail = True;
    return(0);
  }
  switch(MarketInfo(Symbol(), MODE_LOTSTEP))
  {
    case 0.01:
      LotsDecimal = 2;
      break;
    case 0.1:
      LotsDecimal = 1;
      break;
    default:
      Comment("\n .\n   .\n .\n");
      Print(" .    .");
      InitFail = True;
      return(0);
  }

  if(CountOfSell() > 0)
    SellStartLot = FindStartLotSell();
  if(CountOfBuy() > 0)
    BuyStartLot = FindStartLotBuy();
  
  if (Digits == 5 || Digits == 3)
   {
   StaticTakeProfit = StaticTakeProfit*10;
   StaticPipstep = StaticPipstep*10;
   }

   ObjectCreate("Label1",OBJ_LABEL,0,0,0);
   ObjectSet("Label1", OBJPROP_CORNER, 2);
   ObjectSet("Label1", OBJPROP_XDISTANCE, 23);
   ObjectSet("Label1", OBJPROP_YDISTANCE, 11);
   txt1="Swan_ADX_CCI_N1.17";
   ObjectSetText("Label1",txt1,15,"Times New Roman",DodgerBlue);

  return(0);
}

int deinit()
{
  ObjectDelete("Label1");
  return(0);
}

int start()
{ 
  /*****************************************************************************/
  /*   ,                        */ 
  /*****************************************************************************/
  int TotalOrders, PipStep, Ticket, NewTP, LastOrderTP, Signal, MN, Error;
  double NewLots, NewTPPrice;
  
//  if (NewBarOpenTime == Time[0]) return(0);   //   

  if(ExpertStopped) return(0);
  if(InitFail)
  { 
    if(Debug) Print("  .  .");
    ExpertStopped = True;
    return(0);
  }
  BuyOrders   = CountOfBuy();
  SellOrders  = CountOfSell();

  /*****************************************************************************/
  /*    ,        */ 
  /*****************************************************************************/
  if (NewBarOpenTime == Time[0]) return(0);  //   
  NewBarOpenTime = Time[0];
   
  PipStep = StaticPipstep;
  
  LastTickTime = MarketInfo(Symbol(),MODE_TIME);
  TotalOrders = CountOfOrders(); 

    Signal = GetSignal();

    if(ProcessMarketOrders(Signal))
      return(0);

  if(TotalOrders > 0)
  { 
    if (Turbo == 0)
   { 
   if (TotalOrders == 1) PipStep = StaticPipstep;
   if (TotalOrders >= 2) PipStep = NormalizeDouble(PipStep * MathPow(PipStepExponent,(TotalOrders-1)), 0);
   }
   
   if (Turbo == 1)
   { 
   if (TotalOrders == 1) PipStep = StaticPipstep/5*3;
   if (TotalOrders == 2) PipStep = StaticPipstep;
   if (TotalOrders >= 3) PipStep = NormalizeDouble(PipStep * MathPow(PipStepExponent,(TotalOrders-2)), 0);
   }
   
   if (Turbo == 2)
   { 
   if (TotalOrders == 1) PipStep = StaticPipstep/5*2;
   if (TotalOrders == 2) PipStep = StaticPipstep/5*4;
   if (TotalOrders == 3) PipStep = StaticPipstep;
   if (TotalOrders >= 4)
   PipStep = NormalizeDouble(PipStep* MathPow(PipStepExponent,(TotalOrders-3)), 0);
   }
    if(BuyOrders == 1)
      if(BuyStartLot == 0)
      {
        BuyStartLot = GetStartLot(OP_BUY);
        if(OrderTakeProfit() == 0)
          ModifyOrder(OrderOpenPrice() + StaticTakeProfit * Point);
      }
    if(SellOrders == 1)
      if(SellStartLot == 0)
      {
        SellStartLot = GetStartLot(OP_SELL);
        if(OrderTakeProfit() == 0)
          ModifyOrder(OrderOpenPrice() - StaticTakeProfit * Point);
      }

    //  -
    if(BuyOrders > 0 && BuyOrders <= MaxStepCount)
    {
        Signal = OP_BUY;
      if((Ask < FindLastBuyPrice() - (PipStep * Point)) && (Signal == OP_BUY))
      {
        NewLots = NormalizeDouble(BuyStartLot + (BuyStartLot * BuyOrders * LotsExponent), LotsDecimal);
        if(NewLots > MaxLot)
        NewLots = MaxLot;
        
        Ticket = SendMarketOrder(OP_BUY, NewLots, 0, 0, MN_Buy, ExpertName + " - " + BuyOrders, Error);
        if(!(Ticket < 0))
        {
          NewTP = StaticTakeProfit;
          NewTPPrice = NormalizeDouble(CalculateAveragePriceBuy() + (NewTP * Point), Digits);
          if(Debug) Print("  BUY-  ");
          for (int i1 = 0; i1 < OrdersTotal(); i1++) 
          {
            if(OrderSelect(i1, SELECT_BY_POS, MODE_TRADES))
              if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Buy)
                if(OrderType()== OP_BUY) 
                  ModifyOrder(NewTPPrice);
          }
        }
        else
          if(Debug) Print("  BUY-"); 
      }
    }
 
    //  -
    if(SellOrders > 0 && SellOrders <= MaxStepCount)
    {
        Signal = OP_SELL;
      if((Bid > FindLastSellPrice() + (PipStep * Point)) && (Signal == OP_SELL))
      {
        NewLots = NormalizeDouble(SellStartLot + (SellStartLot * SellOrders * LotsExponent), LotsDecimal);
        if(NewLots > MaxLot)
        NewLots = MaxLot;
        
        Ticket = SendMarketOrder(OP_SELL, NewLots, 0, 0, MN_Sell, ExpertName + " - " + SellOrders, Error);
        if(!(Ticket < 0))
        {
          NewTP = StaticTakeProfit;
          NewTPPrice = NormalizeDouble(CalculateAveragePriceSell() - (NewTP * Point), Digits);
          if(Debug) Print("  SELL-  ");
          for (int i2 = 0; i2 < OrdersTotal(); i2++) 
          {
            if(OrderSelect(i2, SELECT_BY_POS, MODE_TRADES))
              if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Sell)
                if(OrderType()== OP_SELL) 
                  ModifyOrder(NewTPPrice);
          }
        }
        else
          if(Debug) Print("  SELL-"); 
      }
    }
  }
}
//+------------------------------------------------------------------+
void SendFirstOrder(int Signal, double Lots)
{
  int Ticket, MN, Error;
  if((Signal == OP_BUY) || (Signal == OP_SELL))
  {
    if(Signal == OP_BUY)
    {
      MN = MN_Buy;
      if(Debug)Print("  BUY");
      if(Debug) Print(" .");
      Ticket = SendMarketOrder(Signal, Lots, 0, 0, MN, ExpertName, Error);
      if(Ticket > 0)
      if(OrderSelect(Ticket,SELECT_BY_TICKET))
      ModifyOrder(OrderOpenPrice() + StaticTakeProfit * Point);
    }
    if(Signal == OP_SELL)
    {
      MN = MN_Sell;
      if(Debug)Print("  SELL");
      if(Debug) Print(" .");
      Ticket = SendMarketOrder(Signal, Lots, 0, 0, MN, ExpertName, Error);
      if(Ticket > 0)
      if(OrderSelect(Ticket,SELECT_BY_TICKET))
      ModifyOrder(OrderOpenPrice() - StaticTakeProfit * Point);
    }
  }
  else
    if(Debug) Print("   ,   .");
  return;
}
//+------------------------------------------------------------------+
int CountOfOrders()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && ((OrderMagicNumber() == MN_Buy)||(OrderMagicNumber() == MN_Sell))) 
        if ((OrderType() == OP_SELL) || (OrderType() == OP_BUY)) 
          count++;
  return(count);
}
//+------------------------------------------------------------------+
int CountOfBuy()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Buy)) 
        if (OrderType() == OP_BUY) 
          count++;
  return(count);
}
//+------------------------------------------------------------------+
int CountOfSell()
{
  int count = 0;
  for (int i = 0; i < OrdersTotal(); i++) 
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if ((OrderSymbol() == Symbol()) && (OrderMagicNumber() == MN_Sell)) 
        if (OrderType() == OP_SELL) 
          count++;
  return(count);
}
//+------------------------------------------------------------------+
int SendMarketOrder(int Type, double Lots, int TP, int SL, int Magic, string Cmnt, int& Error)
{
  double Price, Take, Stop;
  int Ticket, Slippage, Color, Err; 
  bool Delay = False;
  if(Debug) Print(" SendMarketOrder");
  while(!IsStopped())
  {
    if(Debug) Print("  ,  \"\" .");
    if(!IsConnected())
    {
      Error = ERR_NO_CONNECTION;
      Print("   !");
      return(-1);
    }
    if(Debug) Print("   ");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      if(Debug) Print(" 3 ...");
      Sleep(3000);
      Delay = True;
      continue;
    }
    if(Debug) Print("  ");
    if(Delay || (LastTickTime != MarketInfo(Symbol(),MODE_TIME))) 
    {
      if(Debug) Print(" ");
      RefreshRates();
      LastTickTime = MarketInfo(Symbol(),MODE_TIME);
      Delay = False;
    }
    else
    {
      if(Debug) Print(" ");
    }
    switch(Type)
    {
      case OP_BUY:
        if(Debug) Print("   BUY-");
        Price = NormalizeDouble( Ask, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price + TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price - SL * Point, Digits));
        Color = Blue;
        break;
      case OP_SELL:
        if(Debug) Print("   SELL-");
        Price = NormalizeDouble( Bid, Digits);
        Take = IIFd(TP == 0, 0, NormalizeDouble( Price - TP * Point, Digits));
        Stop = IIFd(SL == 0, 0, NormalizeDouble( Price + SL * Point, Digits));
        Color = Red;
        break;
      default:
        if(Debug) Print("    .");
        return(-1);
    }
    Slippage = MarketInfo(Symbol(), MODE_SPREAD);
    if(Debug) Print("Slippage = ",Slippage);
    if(IsTradeAllowed())
    {
      if(Debug) Print(" ,  ...");
      Ticket = OrderSend(Symbol(), Type, Lots, Price, Slippage, Stop, Take, Cmnt, Magic, 0, Color);
      if(Ticket < 0)
      {
        Err = GetLastError();
        if (Err == 4   || /* SERVER_BUSY */
            Err == 129 || /* INVALID_PRICE */ 
            Err == 135 || /* PRICE_CHANGED */ 
            Err == 137 || /* BROKER_BUSY */ 
            Err == 138 || /* REQUOTE */ 
            Err == 146 || /* TRADE_CONTEXT_BUSY */
            Err == 136 )  /* OFF_QUOTES */
        {
          if(Debug) Print("(OrderSend - ", Err, "): ", ErrorDescription(Err));
          if(Debug) Print(" 3 ...");
          Sleep(3000);
          Delay = True;
          continue;
        }
        else
        {
          if(Debug) Print(" (OrderSend - ", Err, "): ", ErrorDescription(Err));
          Error = Err;
          break;
        }
      }
      break;
    }
    else
    {
      if(Debug) Print("  !     .");
      
      break;
    }
  }
  if(Ticket > 0)
    if(Debug) Print("  .  = ",Ticket);
  else
    if(Debug) Print("!   . (ErrorCode = ", Error, ": ", ErrorDescription(Error), ")");
  return(Ticket);
}
//+------------------------------------------------------------------+
double IIFd(bool condition, double ifTrue, double ifFalse) 
{
  if (condition) return(ifTrue); else return(ifFalse);
}
//+------------------------------------------------------------------+
double FindLastBuyPrice() 
{
  double LastPrice = 0;
  
  for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--)
    if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol())
        if(OrderMagicNumber() == MN_Buy) 
          if(OrderType() == OP_BUY) 
          {
            if(LastPrice == 0)
            {
              LastPrice = OrderOpenPrice();
              continue;
            }
            if(OrderOpenPrice() < LastPrice)
            {
              LastPrice = OrderOpenPrice();
            }
          }
  return (NormalizeDouble(LastPrice, Digits));
}
//+------------------------------------------------------------------+
double FindLastSellPrice() 
{
  double LastPrice = 0;

  for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt--) 
    if(OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol()) 
        if(OrderMagicNumber() == MN_Sell) 
          if(OrderType() == OP_SELL) 
          {
            if(LastPrice == 0)
            {
              LastPrice = OrderOpenPrice();
              continue;
            }
            if(OrderOpenPrice() > LastPrice)
            {
              LastPrice = OrderOpenPrice();
            }
          }
  return(NormalizeDouble(LastPrice, Digits));
}
//+------------------------------------------------------------------+
double CalculateAveragePriceBuy()
{
  double AveragePrice = 0;
  double Count = 0;
  
  for (int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Buy)
        if (OrderType() == OP_BUY) 
        {
           AveragePrice += OrderOpenPrice() * OrderLots();
           Count += OrderLots();
        }
  if(AveragePrice > 0 && Count > 0)
    return( NormalizeDouble(AveragePrice / Count, Digits));
  else
    return(0);
}
//+------------------------------------------------------------------+
double CalculateAveragePriceSell()
{
  double AveragePrice = 0;
  double Count = 0;

  for (int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MN_Sell)
        if (OrderType() == OP_SELL) 
        {
           AveragePrice += OrderOpenPrice() * OrderLots();
           Count += OrderLots();
        }
  if(AveragePrice > 0 && Count > 0)
    return( NormalizeDouble(AveragePrice / Count, Digits));
  else
    return(0);
}
//+------------------------------------------------------------------+
bool ModifyOrder( double takeprofit)
{
  while(!IsStopped())
  {
    if(Debug) Print(" ModifyOrder");
    if(IsTradeContextBusy())
    {
      if(Debug) Print("  !");
      Sleep(3000);
      continue;
    }
    if(Debug) Print("  ");
    if(!IsTradeAllowed())
    {
      if(Debug) Print("      !");
      Sleep(3000);
      continue;
    }
    if(Debug) Print(" ,   #",OrderTicket());
    if(Debug) Print("  = ", DoubleToStr(takeprofit, 5));
    if(!OrderModify(OrderTicket(), OrderOpenPrice(), 0, NormalizeDouble(takeprofit,Digits), 0, Yellow))
    {
      if(Debug) Print("   ");
      int Err = GetLastError();
      if(Debug) Print("(",Err,"): ",ErrorDescription(Err));
      break;
      
    }
    else
    {
      if(Debug) Print("   ");
      break;
    }
  }
  return(True);
}
//+------------------------------------------------------------------+
int GetSignal()
{  
  double LevelADX     = iADX(NULL,0,PeriodADX,4,MODE_MAIN,0);//  
  double Delta_01_ADX =(iADX(NULL,0,PeriodADX,4,MODE_MAIN,0) // ,    
                      - iADX(NULL,0,PeriodADX,4,MODE_MAIN,2));
                     
      if ((iCCI(NULL,0,Per1,6,0)>(Drop1))               //CCI-1 > Drop1
        &&(iCCI(NULL,0,Per1,6,0)>iCCI(NULL,0,Per1,6,1)) //CCI-1  
        &&(iCCI(NULL,0,Per2,6,0)>(Drop2))
        &&(iCCI(NULL,0,Per2,6,0)>iCCI(NULL,0,Per2,6,1)))//CCI-2 
      if  ((Delta_01_ADX > DeltaADX)                    //  
        && (LevelADX < StopADX))                        //  ,    ,
         //    2- CCI    ,     Buy 
      return(OP_BUY);


      if ((iCCI(NULL,0,Per1,6,0)<(-Drop1))              //CCI-1 < Drop1
        &&(iCCI(NULL,0,Per1,6,0)<iCCI(NULL,0,Per1,6,1)) //CCI-1 
        &&(iCCI(NULL,0,Per2,6,0)<(-Drop2))
        &&(iCCI(NULL,0,Per2,6,0)<iCCI(NULL,0,Per2,6,1)))//CCI-2 
      if  ((Delta_01_ADX > DeltaADX)                    //  
        && (LevelADX < StopADX))                        //  ,    ,
        //    2- CCI    ,     Sell  
      return(OP_SELL);
   return(-1);
}
//+------------------------------------------------------------------+
double GetStartLot(int Type)
{
  double Result = 0;
  for(int i = 0; i < OrdersTotal(); i++)
    if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
      if(OrderSymbol() == Symbol())
        if(OrderType() == Type)
        {
          Result = OrderLots();
          break;
        }
  return(Result);
}
//+------------------------------------------------------------------+
double GetLot(double DefaultLot, double MaxLot)
{
  double Result = DefaultLot;
      //    Risk  %  ,  Risk=0,  StartLots
      Result = NormalizeDouble(AccountEquity() * Risk/10000, LotsDecimal);
      if(Result < StartLots)
      Result = StartLots;
      if(Result > MaxLot)
      Result = MaxLot;
  return(Result);
}
//+-------------------------------------------------------------------------------------+
double FindStartLotBuy() 
{
  double FirstPrice = 0;
  double Lots = 0;

  for (int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS))
      if(OrderSymbol() == Symbol()) 
        if(OrderMagicNumber() == MN_Buy) 
          if(OrderType() == OP_BUY) 
          {
            if(FirstPrice == 0)
            {
              FirstPrice = OrderOpenPrice();
              Lots = OrderLots();
              continue;
            }
            if(OrderOpenPrice() - FirstPrice > 0)
            {
              FirstPrice = OrderOpenPrice();
              Lots = OrderLots();
            }
          }
  return(Lots);
}
//+------------------------------------------------------------------+
double FindStartLotSell() 
{
  double FirstPrice = 0;
  double Lots = 0;

  for (int i = 0; i < OrdersTotal(); i++) 
    if(OrderSelect(i, SELECT_BY_POS))
      if(OrderSymbol() == Symbol()) 
        if(OrderMagicNumber() == MN_Sell) 
          if(OrderType() == OP_SELL) 
          {
            if(FirstPrice == 0)
            {
              FirstPrice = OrderOpenPrice();
              Lots = OrderLots();
              continue;
            }
            if(OrderOpenPrice() - FirstPrice < 0)
            {
              FirstPrice = OrderOpenPrice();
              Lots = OrderLots();
            }
          }
  return(Lots);
}
//+------------------------------------------------------------------+
bool ProcessMarketOrders(int Signal)
{
  bool Result = False;
  if(BuyOrders == 0 && NewCycle)
  {

      if(SellOrders == 0)
      {
        BuyStartLot = 0;

            if(Signal == OP_BUY)
            {
             
              BuyStartLot = GetLot(StartLots, MaxLot);
              SendFirstOrder(OP_BUY, BuyStartLot);
              Result = True;
              return(Result);
            }
      }

  }
  
  if(SellOrders == 0 && NewCycle)
  {

      if(BuyOrders == 0)
      {
        SellStartLot = 0;

            if(Signal == OP_SELL)
            {
              
              SellStartLot = GetLot(StartLots, MaxLot);
              SendFirstOrder(OP_SELL, SellStartLot);
              Result = True;
              return(Result);
            }
      }

  }
  return(Result);
}


